/* FlyStats! is copyright (c) 1999-2000 CRESTO Sylvain <tost>.
 * E-mail: <tost@softhome.net>
 * Contact: #flystats on irc.kewl.org
 *
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 */

#include "extern.h"

Commands *lookup_cmd(Commands *list, const char *cmd)
{
    Commands *c;
    for (c = list; c->cmd; c++) {
	if (!strcasecmp(c->cmd, cmd))
	    return c;
    }
    return NULL;
}

void run_cmd(char *service, User *u, Commands *list, const char *cmd)
{
    Commands *c = lookup_cmd(list, cmd);

    if (c && c->routine) {
	/* Attention c->has_priv peu tre NULL !
	 * En dessous on poura optimiser un peu tout a si on decide que
	 * seul les opers peuvent s'identifier avec la commande IDENTIFY
	 * Pour le moment je sais pas encore trop ce qui serai le mieux
	 * on vera a :)
	 */
	if ((!c->has_priv && (is_oper(u) || !OperOnly)) || (c->has_priv &&
		(!*c->has_priv || (*c->has_priv == 1 && is_oper(u)) ||
		(*c->has_priv > 1 && is_access(u, *c->has_priv))))) {
	    c->routine(u);
	} else notice_lang(service, u, ACCESS_DENIED);
    } else {
	notice_lang(service, u, UNKNOWN_COMMAND, cmd, service);
    }
}

void run_help(char *service, User *u, Commands *list, int helptopic)
{
    char *topic = strtok(NULL, ""), *s;
    Commands *c;

    if (!topic) {
	topic = "HELP";
    } else {
	s = topic;
	while (*s)
	    *s++=toupper(*s);
    }
    c = lookup_cmd(list, topic);

    if (c && c->help!=-1) {
	if (is_oper(u) || (!OperOnly && (!c->has_priv || is_oper(u)))) {
	    notice_lang(service, u, HELP_PRE, service);
	    if (c->help_syntax!=-1)
		notice_lang(service, u, HELP_CMD, topic, c->help_syntax!=-2 ? getstring(u, c->help_syntax) : topic);
	    notice_lang(service, u, c->help);
	    if (is_oper(u) && c->help == STAT_HELP) {
		notice_lang(service, u, STAT_HELP_EX, fRemoveServer>1 ? fRemoveServer : '-',
			fRehash>1 ? fRehash : '-', fRestart>1 ? fRestart : '-', fShutDown>1 ? fShutDown : '-' );
	}
	    if (c->help_example!=-1)
		notice_lang(service, u, HELP_EXAMPLE, c->help_example!=-2 ? getstring(u, c->help_example) : topic);
	    notice_lang(service, u, HELP_POST, service);
	} else {
	    notice_lang(service, u, ACCESS_DENIED);
	}
    } else {
	notice_lang(service, u, NO_HELP_AVAILABLE, topic);
    }
}
