/* FlyStats! is copyright (c) 1999-2000 CRESTO Sylvain <tost>.
 * E-mail: <tost@softhome.net>
 * Contact: #flystats on irc.kewl.org
 *
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 */

#include "extern.h"

int  OPERONLY = 1;

char Conf_File[1024] = "";

#ifndef IRC_UNREAL
#define NEED_REHASH	0
#else
#define NEED_REHASH	1
#endif

RemoteServer *FirstRemoteServer = NULL, *UsedRemoteServer, *BackupRemoteServer;
AccessFlags *accessflags = NULL;

char *ServerName;
#ifdef IRC_UNDERNET
int  ServerNumeric;
#endif
#ifdef IRC_UNREAL
char *IrcNetwork;
#endif
char *ServerDesc;
int  SleepBeforeReconnect;
int  RotateServer;
char *AdminInfo;

int  ServerLagTime;

char *ssNick;
char *ssUser;
char *ssHost;
char *ssRealName;

#ifdef IRC_UNREAL
char *bakssNick;
char *bakssUser;
char *bakssHost;
char *bakssRealName;
char *bakServerDesc;
#endif

int  ScanForProxy;
int  MaxThreadForProxyScan;
int  ScanForWhat;
char *KillReason;
char *AKillCommand;
int  WallOnOperCommand;
int  WallOnIdentify;
int  WallOnFailedIdentify;
int  OperOnly;
int  NotifyOpersMissingServer;
int  WallOnNewOper;

char *IgnoreServerBuf;
char **IgnoreServerList;
int  IgnoreServerCount = 0;

int  PingServerTime;
int  UpdateStatTime;
int  UpdateChanStatTime;

char *DetectLangBuf;
char *DefaultLangBuf;
char *ProxyNotice;
int  DefaultLang;
int  DetectLangCount = 0;

int  LogMaxUser;

int  fRemoveServer = 0;
int  fRehash = 0;
int  fRestart = 0;
int  fShutDown = 0;

char *AccessLevel;

#define OPTIONAL	0x00000000
#define REQUIRED	0x00000002
#define SET		0x00000010
#define STRING		0x00000020
#define STRINGUSER	0x00000040
#define INT		0x00000080
#define TIME		0x00000100
#define DETECTLANG	0x00000200
#define REMOTESERVER	0x00000400
#define CHAR		0x00000800
#define ACCESSFLAGS	0x00001000

struct param {
    char *cmd;
    int type;
    void *data;
    int rehash;
};

    /* Option		Type			Variable	Recharger lors d'un REHASH */
struct param Params[] = {
    { "ServerName",	STRINGUSER | REQUIRED,	&ServerName,	NEED_REHASH },
#ifdef IRC_UNDERNET
    { "ServerNumeric",	INT | REQUIRED,		&ServerNumeric, 0 },
#endif
#ifdef IRC_UNREAL
    { "IrcNetwork",	STRING | REQUIRED,	&IrcNetwork,	0 },
#endif
    { "RemoteServer",	REMOTESERVER | REQUIRED,	&FirstRemoteServer,	1 },
    { "SleepBeforeReconnect", TIME | REQUIRED,	&SleepBeforeReconnect,	1 },
    { "RotateServer",	SET,			&RotateServer,	1 },
    { "ServerDesc",	STRING | REQUIRED,	&ServerDesc,	NEED_REHASH },
    { "AdminInfo",	STRING | OPTIONAL,	&AdminInfo,	0 },
    { "ServerLagTime",	TIME | REQUIRED,	&ServerLagTime,	1 },
    { "ssNick",		STRINGUSER | REQUIRED,  &ssNick,	1 },
    { "ssUser",		STRINGUSER | REQUIRED,  &ssUser,	1 },
    { "ssHost",		STRINGUSER | REQUIRED,  &ssHost,	1 },
    { "ssRealName",	STRING | REQUIRED,	&ssRealName,	1 },
    { "OperOnly",	SET,			&OperOnly,	1 },
    { "NotifyOpersMissingServer",	SET,	&NotifyOpersMissingServer,	1 },
    { "ScanForProxy",	INT | OPTIONAL,		&ScanForProxy,	1 },
    { "MaxThreadForProxyScan",	INT | OPTIONAL,	&MaxThreadForProxyScan,	1 },
    { "ScanForWhat",	INT | OPTIONAL,		&ScanForWhat,	1 },
    { "ProxyNotice",	STRING | OPTIONAL,	&ProxyNotice,	1 },
    { "KillReason",	STRING | OPTIONAL,	&KillReason,	1 },
    { "AKillCommand",	STRING | OPTIONAL,	&AKillCommand,	1 },
    { "WallOnOperCommand", SET,			&WallOnOperCommand,	1 },
    { "WallOnIdentify", SET,			&WallOnIdentify,	1 },
    { "WallOnFailedIdentify", SET,		&WallOnFailedIdentify,	1 },
    { "WallOnNewOper",	SET,			&WallOnNewOper, 	1 },
    { "IgnoreServer",	STRING | OPTIONAL,	&IgnoreServerBuf,	1 },
    { "PingServerTime",	TIME | REQUIRED,	&PingServerTime,	1 },
    { "UpdateStatTime",	TIME | REQUIRED,	&UpdateStatTime,	1 },
    { "UpdateChanStatTime",	TIME | REQUIRED,	&UpdateChanStatTime,	1 },
    { "DetectLang",	DETECTLANG | OPTIONAL,	&DetectLangBuf,	1 },
    { "DefaultLang",	STRING | REQUIRED,	&DefaultLangBuf,	1 },
    { "LogMaxUser",	SET,			&LogMaxUser,	1 },
    { "RemoveServer",	CHAR | SET,		&fRemoveServer,	1 },
    { "Rehash",		CHAR | SET,		&fRehash,	1 },
    { "Restart",	CHAR | SET,		&fRestart,	1 },
    { "ShutDown",	CHAR | SET,		&fShutDown,	1 },
    { "Access",		ACCESSFLAGS | OPTIONAL,	&AccessLevel,	1 },
    { NULL },
}; 

/* Initialise les options de type SET a zero pour un rehash */
void reset_param()
{
    struct param *cmdlist;
    RemoteServer *rs1 = FirstRemoteServer, *rs2;
    AccessFlags *af = accessflags;
    User *u1 = identified;

    for (cmdlist = Params; cmdlist->cmd; cmdlist++)
    if (cmdlist->rehash && (cmdlist->type & SET))
	*(int *)cmdlist->data = 0;

#ifdef IRC_UNREAL
	/* sauvegarde certains paramtres pour la mise  jour " chaud" */
    bakServerDesc = strdup(ServerDesc);
    bakssNick = strdup(ssNick);
    bakssUser = strdup(ssUser);
    bakssHost = strdup(ssHost);
    bakssRealName = strdup(ssRealName);
#endif

	/* On sauve le serveur courant au cas oy il ne serai plus
	 * present aprhs le REHASH
	 */
    BackupRemoteServer = malloc(sizeof(RemoteServer));
    BackupRemoteServer->name = strdup(UsedRemoteServer->name);
    BackupRemoteServer->port = UsedRemoteServer->port;
    BackupRemoteServer->pass = strdup(UsedRemoteServer->pass);

	/* Libere les RemoteServer,
 	 * on commence par casser la boucle
 	 */
    FirstRemoteServer->prev->next = NULL;
    while (rs1) {
	rs2 = rs1->next;
	free(rs1->name);
	free(rs1->pass);
	free(rs1);
	rs1=rs2;
    }
    FirstRemoteServer = NULL;

	/* Libere les AccessFlags */
    while (af) {
	accessflags = af->next;
	free(af->login);
	free(af->mask);
	free(af->password);
	free(af->flags);
	free(af);
	af=accessflags;
    }
    accessflags = NULL;

	/* Desidentifis les utilisateurs */
    while (u1) {
        identified = u1->ident_next;
	u1->ident_next = u1->ident_prev = NULL;
        free(u1->flags);
	u1->flags = NULL;
        u1 = identified;
    }
    identified = NULL;

    if (DetectLangCount)   /* libere la memoire */
	free_detectlang();
}

int check_missing_parameter()
{
    struct param *cmdlist;
    int res = 0;
    for (cmdlist = Params; cmdlist->cmd; cmdlist++)
    if ((cmdlist->type & REQUIRED) && !(cmdlist->type & SET))
    if (((cmdlist->type & STRING || cmdlist->type & STRINGUSER) && !*(char **)cmdlist->data) ||
		(((cmdlist->type & INT) || (cmdlist->type & CHAR)) && !*(int *)cmdlist->data) ||
		((cmdlist->type & TIME) && !*(int *)cmdlist->data)) {
	log("ERROR in %s: %s missing\n", Conf_File, cmdlist->cmd);
	res = 1;
    }
    return res;
}

int store_data(char *cmd, char *data, int linenum)
{
    struct param *cmdlist;
    int c;
    char *s;
    time_t t;
    for (cmdlist = Params; cmdlist->cmd; cmdlist++)
    if (!strcasecmp(cmdlist->cmd, cmd)) {
	/* si c'est un rehash et que l'option ne doit pas tre recharge on la saute */
	if (statrun && !cmdlist->rehash)
	    return 1;
	if (cmdlist->type & CHAR) {	/* CHAR trait avant le SET pour la rinitialisation
					 * automatique des flags
					 */
	    if (!data || strlen(data)>2 || !isalpha(*data)) {
		log("ERROR in %s (%d): '%s' must be an alphabetic character [A..Z or a..z]\n", Conf_File, linenum, cmd);
		return 0;
	    }
	    *(char *)cmdlist->data = *data;
	} else if (cmdlist->type & SET) {
	    if (*data) {
		log("ERROR in %s (%d): too many parameters for '%s'\n", Conf_File, linenum, cmd);
		return 0;
	    }
	    *(int *)cmdlist->data = 1;
	} else if (cmdlist->type & STRING) {
	    if (*(char **)cmdlist->data)	/* libere la memoire en cas de rehash */
		free(*(char **)cmdlist->data);
	    *(char **)cmdlist->data = strdup(data);
	} else if (cmdlist->type & STRINGUSER) {
	    if (strchr(data, '@')) {
		log("ERROR in %s (%d): %s: '@' is not allowed\n", Conf_File, linenum, cmd);
		return 0;
	    }
	    if (*(char **)cmdlist->data)	/* libere la memoire en cas de rehash */
		free(*(char **)cmdlist->data);
	    *(char **)cmdlist->data=strdup(data);
	} else if (cmdlist->type & INT) {
	    c = strtol(data, &s, 0);
	    if (*s || c<0 || c > 65535) {
		log("ERROR in %s (%d): '%s' must be a number in range [0..65535]\n", Conf_File, linenum, cmd);
		return 0;
	    }
	    *(int *)cmdlist->data = c;
	} else if (cmdlist->type & TIME) {
	    if ((t = dotime(data, 0))==-1) {
		log("ERROR in %s (%d): Expected a time value for parameter '%s'\n", Conf_File, linenum, cmd);
		return 0;
	    }
	    *(time_t *)cmdlist->data = t;
	} else if (cmdlist->type & DETECTLANG) {
	    char *s = data, *d = s;
	    int fin = 0, lang;

	    while (*s && *s!=':')
		s++;
	    if (!*s) {
		log("ERROR in %s (%d): Found only language name '%s'\n", Conf_File, linenum, cmd);
		return 0;
	    }
	    *(s++)=0;
	    if ((lang = findlang_by_file(d))==-1) {
		log("ERROR in %s: Unknown language '%s'\n", Conf_File, d);
		return 0;
	    }
	    d=s;
	    do {
		while (*s && *s!=':')
		    s++;
		if (!*s || *s=='\n' || *s=='\r')
		    fin = 1;
		if (*s)
		    *s++ = 0;
		if (!*d) {
		    log("ERROR in %s (%d): Found NULL mask in DetectLang\n", Conf_File, linenum);
		    return 0;
		}
		new_detectlang(d, lang);

		d = s;
	    } while (!fin);
	} else if (cmdlist->type & REMOTESERVER) {
	    char *s = data, *d = data, *servtmp;
	    int port = 0;	/* Syntaxe de REMOTESERVER
				 * serveur:port:password
				 */
	    while(*s && *s!=':')
		s++;
	    if (*s && s!=data) {
		servtmp = d;
		*s=0;
		d=++s;
		while(*s && *s!=':')
		    s++;
		*s=0;
		if (strspn(d, "0123456789") == strlen(d) && (port=atoi(d))) {
		    s++;
		    if (s) {
			RemoteServer *remoteserv = malloc(sizeof(RemoteServer));
			remoteserv->name = strdup(servtmp);
			remoteserv->port = port;
			remoteserv->pass = strdup(s);
			remoteserv->prev = NULL;
			remoteserv->next = FirstRemoteServer;
			if (FirstRemoteServer)
			    FirstRemoteServer->prev = remoteserv;
			FirstRemoteServer = remoteserv;
		    }
		}
	    }
	    if (!port) {
		log("ERROR in %s (%d): RemoteServer new syntax is <servername:port:password>. Servername and password are string, "
			"port must be a number in range [1..65535]", Conf_File, linenum);
		return 0;
	    }
	} else if (cmdlist->type & ACCESSFLAGS) {
	    char *s = data, *d = data, *login, *pass;	/* Syntaxe de ACCESSFLAGS
					 * flags:login:password:host1:[host2:...]
					 */
	    int hc=0;
	    while(*s && *s!=':')
		if (!isalpha(*(s++))) {
			/* erreur, les flags doivent etre des caracteres alphabetiques */
		    *(s=data)=0;
		}
	    if (*s && s!=data) {
		*s=0;
		login=++s;
		while (*s && *s!=':')
		    s++;
		*s=0;
		if (*login) {
		    pass=++s;
		    while(*s && *s!=':')
			s++;
		    *s=0;
		    if (*pass) {
			AccessFlags *tmpaccess;
			d=++s;
			    /* traite la serie d'host */
			while(*d) {
			    if (*s==':' || !*s) {
				if (*s==':')
				    *(s++)=0;
				if (*d==':') {
				    log("WARNING in %s (%d): Found NULL host is Access. Access syntax is "
						"<flags:password:host:[host:...]>", Conf_File, linenum);
				    return 0;
				}
				/* nouvelle host */
				hc=1;
				tmpaccess = calloc(sizeof(AccessFlags), 1);
				tmpaccess->flags = strdup(data);
				tmpaccess->login = strdup(login);
				tmpaccess->password = strdup(pass);
				tmpaccess->mask = strdup(d);
				if (accessflags)
				    accessflags->prev = tmpaccess;
				tmpaccess->next = accessflags;
				accessflags=tmpaccess;
#ifdef ALLOW_DEBUG
				if (debug)
				    log("New access <flags==%s:login==%s:password==%s:host==%s>", data, login, pass, d);
#endif
				d=s;
			    }
			    s++;
			}
			if (!hc) {
			    log("ERROR in %s (%d): Access syntax is <flags:login:password:host:[host:...]>. Host must "
				"be a non-NULL string", Conf_File, linenum);
			    return 0;
			}
		    } else {
			log("ERROR in %s (%d): Access syntax is <flags:login:password:host:[host:...]>. Password must be a "
				"non-NULL string", Conf_File, linenum);
			return 0;
		    }
		} else {
		    log("ERROR in %s (%d): Access syntax is <flags:login:password:host:[host:...]>. Login must be a "
			"non-NULL string", Conf_File, linenum);
		}
	    } else {
		log("ERROR in %s (%d): Access syntax is <flags:login:password:host:[host:...]>. Flags must be alphabetics "
			"characters", Conf_File, linenum);
		return 0;
	    }
	}
	return 1;
    }
    log("%s in %s (%d): Unknown option '%s'\n", !tolerance ? "ERROR" : "WARNING", Conf_File, linenum, cmd);
    return !tolerance;
}

int parse_conf(char *buf, int ln)
{
    char *p = buf;
    int q = 0, res = 1;
    char varname[512], varcontent[512];

    if (*buf) {
	do {
	    if (*p=='"') q =! q;
	    else if (*p=='#' && !q) {
		*p = 0;
		break;
	    }
	} while (*++p);
	trimleft(buf);
	if (!*buf)
	    return 1;
	trimright(buf);
	p = buf;
	while (*p && *p!=32 && *p!=9)
	    p++;
	if (*p==32 || *p==9) {
	    *p++=0;
	    strcpy(varcontent, p);
	    trimleft(varcontent);
	} else *varcontent = 0;
	strcpy(varname, buf);
	if (*varcontent && !ispaire(varcontent, '"')) {
	    log("ERROR in %s (%d): Unbalanced quotes.\n", Conf_File, ln);
	    res = 0;
	}
	trimex(varcontent, '"');
	return store_data(varname, varcontent, ln);
    }
    return res;
}

int load_config()
{
    FILE *cf_file;
    char buf[512];
    int ln = 0, er = 0, i;

    sprintf(Conf_File, "%s%s", DataDirectory ? DataDirectory : "", CONF_FILE);
    if ((cf_file = fopen(Conf_File, "r"))) {
	if (statrun)
	    reset_param();
	while ((fgets(buf, 512, cf_file)))
	    if (!parse_conf(buf, ++ln)) er++;
	fclose(cf_file);
	if (check_missing_parameter())
	    er++;
	update_flyflags();
#ifdef IRC_UNDERNET
	if (ServerNumeric<1 || ServerNumeric>64) {
	    log("ERROR in %s: ServerNumeric must be between 1 and 64\n", Conf_File);
	    er++;
	}
#endif
	if (FirstRemoteServer) {
		/* Ferme la boucle des RemoteServer (si statrun on regarde si le serveur courant
		 * est toujours bien dans la liste sinon on le rajoute en emetant un WARNING
		 */
	    RemoteServer *RemoteTmp = FirstRemoteServer, *rscache = NULL;
	    int currentserver = 0;

	    while (RemoteTmp) {
		rscache = RemoteTmp;
		if (statrun && !currentserver && RemoteTmp->port == BackupRemoteServer->port &&
			!strcasecmp(RemoteTmp->name, BackupRemoteServer->name) &&
			!strcasecmp(RemoteTmp->pass, BackupRemoteServer->pass)) {
		    UsedRemoteServer = RemoteTmp;
		    currentserver = 1;
                    break;
                }
                RemoteTmp = RemoteTmp->next;
	    }
	    if (statrun) {
		if (!currentserver) {
		    /* On rajoute le serveur courant et on mets ` jour le UsedRemoteServer */
		    rscache->next = BackupRemoteServer;
		    BackupRemoteServer->prev = rscache;
		    UsedRemoteServer = rscache = BackupRemoteServer;
		} else {
		    free(BackupRemoteServer->name);
		    free(BackupRemoteServer->pass);
		    free(BackupRemoteServer);
		}
	    } else {
		UsedRemoteServer = FirstRemoteServer;
	    }
	    /* on ferme la boucle */
	   rscache->next=FirstRemoteServer;
	   FirstRemoteServer->prev=rscache;
	} else {
	    log("ERROR in %s: RemoteServer is required\n", Conf_File);
	    if (statrun)
		UsedRemoteServer = FirstRemoteServer = BackupRemoteServer;
	    er++;
	}
#ifdef USETHREAD
	if (ScanForProxy && !MaxThreadForProxyScan) {
	    log("ERROR in %s: MaxThreadForProxyScan is required when ScanForProxy != 0\n", Conf_File);
	    er++;
	}
	if (ScanForProxy && (ScanForWhat<1 || ScanForWhat>3)) {
	    log("ERROR in %s: ScanForWhat is required when ScanForProxy != 0 and must be in range [1..3]\n", Conf_File);
	    er++;
	}
	if ((ScanForProxy & 4) && !KillReason) {
	    log("ERROR in %s: KillReason is required when ScanForProxy & 4\n", Conf_File);
	    if (statrun)
		KillReason = strdup("Insecure Proxy/Wingate");
	    er++;
	}
	if ((ScanForProxy & 2) && !AKillCommand) {
            log("ERROR in %s: AKillCommand is required when ScanForProxy & 2\n", Conf_File);
	    if (statrun) {
		char tmp[512];
		sprintf(tmp, "%s :AKillCommand is invalid! Cannot AKill proxy/wingate users", WALLOPS);
		AKillCommand = strdup(tmp);
	    }
	    er++;
	}
	if (!ProxyNotice && ScanForProxy) {
	    log("ERROR in %s: ProxyNotice is required when ScanForProxy != 0\n", Conf_File);
	    if (statrun)
		ProxyNotice = strdup("You are using an insecure proxy/wingate");
	    er++;
	}
#else
	if (ScanForProxy) {
	    log("WARNING: ScanForProxy ignored. You must recompile FlyStats with USEPROXY\n");
	}
#endif
	if (IgnoreServerBuf) {
	    char **PreIgnoreServerList = NULL;
	    char *s = IgnoreServerBuf, *d = s;
	    int fin = 0, PreIgnoreServerCount = 0;
	    do {
		while (*s && *s!=':')
		    s++;
		if (!*s)
		    fin = 1;
		*s = 0;
		if (!*d) {
		    log("ERROR in %s: Found NULL server in IgnoreServer\n", Conf_File);
		    for (i = 0; i < PreIgnoreServerCount; i++)	/* libere la memoire */
			free(PreIgnoreServerList[i]);
		    return 0;
		}
		
		PreIgnoreServerList = realloc(PreIgnoreServerList, sizeof(char *) * ++PreIgnoreServerCount);
		PreIgnoreServerList[PreIgnoreServerCount-1] = strdup(d);
		d = s+1;
	    } while (!fin);
	    for (i = 0; i < IgnoreServerCount; i++)		/* libere la memoire */
		free(IgnoreServerList[i]);
	    IgnoreServerList = PreIgnoreServerList;
	    IgnoreServerCount = PreIgnoreServerCount;
	} else {
	    for (i = 0; i < IgnoreServerCount; i++)		/* libere la memoire */
		free(IgnoreServerList[i]);
	    IgnoreServerList = NULL;
	    IgnoreServerCount = 0;
	}
	if (DefaultLangBuf && ((DefaultLang = findlang_by_file(DefaultLangBuf)) == -1)) {
	    log("ERROR in %s: Unknown DefaultLang '%s'\n", Conf_File, DefaultLangBuf);
	    er++;
	}
	if ((fRemoveServer || fRehash || fRestart || fShutDown) &&
		!accessflags) {
	    char *buf = malloc(150);
	    if (fRemoveServer)
		strcat(buf, "RemoveServer, ");
	    if (fRehash)
		strcat(buf, "Rehash, ");
	    if (fRestart)
		strcat(buf, "Restart, ");
	    if (fShutDown)
		strcat(buf, "ShutDown  ");
	    buf[strlen(buf)-2]=0;
	    log("WARNING in %s: You're using flags is Stat. conf with '%s' but I cannot find an "
		"'Access' option", Conf_File, buf);
	    free(buf);
	}
	return (!er);
    } else {
	log("ERROR: cannot load conf file '%s'\n", Conf_File);	
    }
    return 0;
}
