/* FlyStats! is copyright (c) 1999-2000 CRESTO Sylvain <tost>.
 * E-mail: <tost@softhome.net>
 * Contact: #flystats on irc.kewl.org
 *
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 */

/* Messages irc (06/11/99)
 */
typedef struct {
    const char *cmd;
    void (*func)(char *source, int ac, char **av);
} Message;

#define	UMODE_I	1
#define	UMODE_O	2

/* RemoteServer */
typedef struct remoteserver_ RemoteServer;
struct  remoteserver_ {
    RemoteServer *next, *prev;
    char *name;
    int port;
    char *pass;
};

/* AccessFlags */
typedef struct accessflags_ AccessFlags;
struct accessflags_ {
    AccessFlags *next, *prev;
    char *mask;
    char *login;
    char *password;
    char *flags;
};

/* Buffer pour les commandes reu par le serveur (06/11/99)
 */
typedef struct command_ Command;
typedef struct domain_ Domain;

struct command_ {
    Command *next, *prev;
    char *source;
    int nbrcmd;
    char **cmd;
    Message *message;
};

typedef struct user_ User;

/* Map des server */
typedef struct server_ Server;
struct server_ {
    Server *prev, *next;
    Server *hub, *leaf;		/* hub = hub de ce serveur
				 * leaf = leaf de ce serveur
				 */
    char *name;
    char *remote;
    char *desc;
#ifdef IRC_UNDERNET
    char yxx[4];
    User *userlist[122];
#endif
    int pos;
    int connected;	/* 0 = split 1 = connect 2 = connect sans stat sur les ping */
    char *version;

	/* gestion du nombre d'user */
    int count, maxcount;
    long averagetotal[4];
    long averagecount[4];
    long average[4];	/* moyennes calculs */
    long totalcount;
    time_t timemaxcount;

	/* nombre d'opers et kill */
    int opercount, maxopercount;
    int killcount, servkillcount;
    time_t timelastsplit, timelastjoin;

	/* gestion du lag */
    int pingcount;
    int pongcount;
    int lag;
    time_t sendlastping;
};

/* Language file */

typedef struct language_ Language;
struct language_ {
    char *langname;
    char *langshort;
    int num;
    char **text;
};

/* Structure User */
struct user_ {
    User *next, *prev;
    char *nick;
    char *username;
    char *host;
    Server *server;	/* tjrs non NULL sauf en cas de bug :) (avec l'ircu 2.10.* a
			 * provoquerai surement un segfault ou un memory leaks du statserv */
    Domain *domain;	/* NULL si l'host n'est pas resolve
			 * (ou si elle est invalide ce qui ne devrait jamais arriver)
			 */
    int language;
    short mode;
    time_t signon;
#ifdef IRC_UNDERNET
    char yxx[4];
    User *yxx_next, *yxx_prev;
#endif
	/* Prochain user  scanner pour un proxy */
    User *proxy_next, *proxy_prev;
	/* User identifis */
    User *ident_next, *ident_prev;
    char *flags;	/* flags aprs l'identification */
};

/* Strcuture UsingThread */

typedef struct usingproxythread_ UsingProxyThread;
struct usingproxythread_ {
   UsingProxyThread *next, *prev;
   char *nick;
   char *username;
   char *host;
   int action;	/* 0 = libre
		 * 1 = test en cours
		 * 2 = test termin, c un proxy non securis
		 */
};


/* Commandes */
typedef struct {
    const char *cmd;

    void (*routine)(User *u);
    int *has_priv;	/* 0 = aucun necessaire
			 * 1 = opers only
			 * > = flags required */

    int help;
    int help_syntax;
    int help_example;
} Commands;

/* Liste des domaines */

struct domain_ {
    Domain *next, *prev;
    char *name;
    char *country;
    int count, maxcount;
    long averagetotal[4];
    long averagecount[4];
    long average[4];	/* moyenne calcules */
    long totalcount;
    time_t firstlogin;
    time_t lastlogin;
    time_t timemaxcount;
};

/* Proxy */

typedef struct proxyaction_ ProxyAction;
struct proxyaction_ {
    char *nick;
    char *username;
    char *host;
    int status;	/* 0 = non utilis
		 * 1 = test en cours
		 * 2 = c'est un proxy non securis */
};

/* Cache Proxy */

typedef struct proxyhost_ ProxyHost;
struct proxyhost_ {
    ProxyHost *prev, *next;
    char *host;
    int action;	/* 1 = socks5
		 * 2 = socks4
		 * 4 = wingate
		 * 8 = cached */
};

/* Auto dtection du language */

typedef struct autodetectlang_ AutoDetectLang;
struct autodetectlang_ {
    AutoDetectLang *prev, *next;
    char *mask;
    int language;
};
