/* FlyStats! is copyright (c) 1999-2000 CRESTO Sylvain <tost>.
 * E-mail: <tost@softhome.net>
 * Contact: #flystats on irc.kewl.org
 *
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 */

#include "extern.h"

#define HASH(domain)	(((domain)[0]&31)<<5 | ((domain)[1]&31))
Domain *domainlist[1024];

int domaincount = 0;
int resolvecount = 0;
 
Domain *new_domain(char *name)
{
    Domain *domain = calloc(sizeof(Domain), 1), **list;

#ifdef ALLOW_DEBUG
    if (debug)
	log("New domain '%s'", name);
#endif

    domain->name = strdup(name);
    domain->country = find_country(name);
    list = &domainlist[HASH(name)];
    domain->next = *list;
    if (*list)
	(*list)->prev = domain;
    *list = domain;
    domaincount++;
    return domain;
}

Domain *find_domain(const char *name)
{
    Domain *domain = domainlist[HASH(name)];

    for (domain = domainlist[HASH(name)]; domain; domain = domain->next)
    if (!strcasecmp(domain->name, name)) {
	return domain;
    }
    return NULL;
}

void domain_adduser(Domain *domain)
{
    if (!domain->count)
	domain->firstlogin = time(NULL);
    domain->count++;
    domain->totalcount++;
    domain->lastlogin = time(NULL);
    if (domain->count>domain->maxcount) {
#ifdef ALLOW_DEBUG
	if (debug)
	    log("New maxuser for domain '%s': %d", domain->name, domain->count);
#endif
	domain->timemaxcount = time(NULL);
	domain->maxcount = domain->count;
    }
}

/* mets  jours les stats sur les domaines */
void update_domain_stats(int timepos, int rzero)
{
    Domain *domain;

    for (domain = firstdomain(); domain; domain = nextdomain()) {
	if (!rzero) {
	    domain->averagecount[timepos]++;
	    domain->averagetotal[timepos]= domain->averagetotal[timepos]+domain->count;
	} else {
	    domain->averagecount[timepos] = 1;
	    domain->averagetotal[timepos]= domain->count;
	}
	domain->average[timepos] = domain->averagetotal[timepos] / domain->averagecount[timepos];
    }
}

/*************************************************************************/

/* Iterate over all domains in the domain list.  Return NULL at end of list. */

static Domain *current;
static int next_index;

Domain *firstdomain(void)
{
    next_index = 0;
    current=NULL;
    while (next_index < 1024 && !current)
	current = domainlist[next_index++];
    return current;
}

Domain *nextdomain(void)
{
    if (current)
	current = current->next;
    if (!current && next_index < 1024) {
	while (next_index < 1024 && !current)
	    current = domainlist[next_index++];
    }
    return current;
}
