/* FlyStats! is copyright (c) 1999-2000 CRESTO Sylvain <tost>.
 * E-mail: <tost@softhome.net>
 * Contact: #flystats on irc.kewl.org
 *
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 */

#include "extern.h"

int read_int16(int *ret, FILE *f)
{
    int c1, c2;

    c1 = fgetc(f);
    c2 = fgetc(f);
    if (c1 == EOF || c2 == EOF)
	return 0;
    *ret = c1<<8 | c2;
    return 1;
}

int write_int16(int val, FILE *f)
{
    return (!(fputc((val>>8) & 0xFF, f) == EOF || fputc(val & 0xFF, f) == EOF));
}

int read_string(char **ret, FILE *f)
{
    char *s;
    int len;

    if (read_int16(&len, f) < 0 || len == 0) {
	*ret = NULL;
	return 0;
    }
    s = malloc(len);
    if (len != fread(s, 1, len, f)) {
	free(s);
	return 0;
    }
    *ret = s;
    return 1;
}

int write_string(const char *s, FILE *f)
{
    int len;

    if (!s)
	return write_int16(0, f);
    len = strlen(s);
    if (len > 512)
	len = 512;
    if (write_int16((int)(len+1), f) < 0)
	return 0;
    if (len > 0 && fwrite(s, 1, len, f) != len)
	return 0;
    return (fputc(0, f) != EOF);
}
