/* FlyStats! is copyright (c) 1999-2000 CRESTO Sylvain <tost>.
 * E-mail: <tost@softhome.net>
 * Contact: #flystats on irc.kewl.org
 *
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 */

#include "extern.h"

/* show help then exit (05/11/99) */

void show_help(char *prog)
{
    printf("    Usage: %s [OPTION]...\n\n"
	"    Informative output:\n"
	"\t-about              Show copyright informations, then exit\n"
	"\t-data <directory>   Data directory location (stat.conf, lang and log)\n"
	"\t-debug              Show debug informations in log files"
#ifdef ALLOW_DEBUG
	"\n"
#else
	" (not available)\n"
#endif
	"\t-info               Show compilation informations, then exit\n"
	"\t-help               Print this help, then exit\n"
	"\t-nofork             Do not fork after startup\n"
	"\t-tolerance          Ignore unknown options in Stat. conf file\n"
	"\t-version            Print Services version number, then exit\n\n"
	"    Look README file for more informations.\n", prog);
}

void do_copyright()
{
	/* Look people. I'm not asking for payment, praise, or anything like
	 * that for using Flystats, so at least I would like to get some
	 * recognition for my works. So please be nice, and don't remove the
	 * copyright message below.
	 * CRESTO Sylvain <tost> tost@softhome.net
	 */
    printf("FlyStats! is copyright (c) 1999-2000 CRESTO Sylvain <tost>.\n"
	"E-mail: <tost@softhome.net>\n"
	"Contact: #flystats on irc.kewl.org\n");
}

void do_info()
{
	/* Compilation informations
	 */
    printf("Compiled for %s\nMultiThreaded code\t- %s\nDebug code support\t- %s\n",
#if defined(IRC_UNREAL)
	"Unreal ircd"
#elif defined(IRC_UNDERNET_29)
	"UnderNet ircu 2.9.x"
#elif defined(IRC_DALNET)
	"DalNet DreamForge ircd (or compatible like Twilight)"
#elif defined(IRC_UNDERNET)
	"UnderNet ircu 2.10.x (P10)"
#elif defined(IRC_HYBRID)
	"EfNet Hybrid 5.x ircd"
#else
	"DalNet Bahamut ircd"
#endif
	,
#ifdef USETHREAD
	"enabled"
#else
	"disabled"
#endif
	,
#ifdef ALLOW_DEBUG
	"enabled"
#else
	"disabled"
#endif
	);
}
