/* FlyStats! is copyright (c) 1999-2000 CRESTO Sylvain <tost>.
 * E-mail: <tost@softhome.net>
 * Contact: #flystats on irc.kewl.org
 *
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 */

#include "extern.h"

AutoDetectLang *detectlanglist[255];

char *filelang[]={"lang/flyfr", "lang/flyuk", NULL};

char **FlyLang[NUM_LANGS];
char filename[1024];
char buf[10000];

int LanguageNum;

int topicnum = -1;

void new_detectlang(char *host, int lang)
{
    AutoDetectLang *detectlang = calloc(sizeof(AutoDetectLang), 1), **list;
    detectlang->mask = strdup(host);
    detectlang->language = lang;
    list = &detectlanglist[(unsigned char) (host[strlen(host)-1])];
    detectlang->next = *list;
    if (*list)
        (*list)->prev = detectlang;
    *list = detectlang;
    DetectLangCount++;
}

int detectlang(const char *host)
{
    AutoDetectLang *detectlang = detectlanglist[(unsigned char) (host[strlen(host)-1])];
    for (detectlang = detectlanglist[(unsigned char) (host[strlen(host)-1])]; detectlang; detectlang = detectlang->next)
    if (match_wild_nocase(detectlang->mask, host))
        return detectlang->language;
    return -1;
}

void free_detectlang()
{
    AutoDetectLang **current = NULL, *nextentry;
    int next_index = 0;
    DetectLangCount = 0;
    do {
	while (next_index < 255 && !current)
	    current = &detectlanglist[next_index++];
	if (current) {
	   do {
		nextentry = (*current)->next;
		free((*current)->mask);
		(*current)->mask=NULL;
		free((*current));
		*current = nextentry;
		if (!current) log("fin de current");
	    } while (current);
	    detectlanglist[next_index-1]=NULL;
	}
    } while (next_index < 255);
}

void notice_lang(char *source, User *u, int message, ...)
{
    va_list args;
    char *s = buf, *d = buf;

    va_start(args, message);
    vsnprintf(buf, sizeof(buf), FlyLang[u->language][message], args);
    while (*s && *d) {
	if ((*s=='\r' && !*(s+1)) || *s=='\n') {
	    *s=0;
	    SockWrite(":%s NOTICE %s :%s", source, nickyxx(u), d);
	    d=++s;
	}
	s++;
    }
    va_end(args);
}

void syntax_error(char *source, User *u, char *cmd, int message)
{
    char *s = buf, *d = buf;

    snprintf(buf, sizeof(buf), getstring(u, SYNTAX_ERROR), getstring(u, message), source, cmd);

    while (*s) {
	if ((*s=='\r' && !*(s+1)) || *s=='\n') {
	    *s=0;
	    SockWrite(":%s NOTICE %s :%s", source, nickyxx(u), d);
	    d=++s;
	}
	s++;
    }
}

int load_one_lang(int nl) {
    FILE *f;
    int current_topic;
    int i, nt;

    sprintf(filename, "%s%s", DataDirectory ? DataDirectory : "", filelang[nl]);
    f = fopen(filename, "r");

    if (!f) {
	log("Warning (%s): Cannot load language file\n", filename);
	return 0;
    }
    read_int16(&current_topic, f);
    if (current_topic<1) {
	log("Warning (%s): language file is empty\n", filename);
	return 0;
    }
    if (topicnum==-1) {
	topicnum = current_topic;
    } else if (topicnum!=current_topic) {
	log("Warning (%s): topic number mismatch (found %d, %d expected)\n", filename,
			current_topic, topicnum);
	return 0;
    }
    FlyLang[nl] = malloc(sizeof(char *) * topicnum);
    for (i = 0; i < current_topic; i++) {
	read_int16(&nt, f);
	if (nt<1) {
	    log("Warning (%s): No entry for topic %d\n", filename, i);
	    FlyLang[nl][i] = NULL;
	} else {
	    FlyLang[nl][i] = malloc(nt+1);
	    fread(FlyLang[nl][i], 1, nt, f);
	}	
    }
    fclose(f);
    return 1;
}

void load_lang()
{
    for (LanguageNum=0; filelang[LanguageNum]; LanguageNum++)
	load_one_lang(LanguageNum);
    LanguageNum--;
}

int findlang_by_file(char *name)
{
    int i;
    for (i = 0; filelang[i]; i++)
	if (!strcmp(filelang[i], name))
	    return i;
    return -1;
}
