/* FlyStats! is copyright (c) 1999-2000 CRESTO Sylvain <tost>.
 * E-mail: <tost@softhome.net>
 * Contact: #flystats on irc.kewl.org
 *
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 */

#include "extern.h"

FILE *logfile;
int lastdaylog = -1;


/* Log une action (06/11/99)
 */

int log(char *fmt,...)
{
    time_t t;
    struct tm tm;
    char buftime[256], buf[512];
    va_list ap;

    va_start (ap, fmt);
    vsnprintf (buf, 512, fmt, ap);
    strcat (buf, "\n");
    if (nofork)
	printf("LOG: %s", buf);

    time(&t);
    tm = *localtime(&t);
    if (lastdaylog!=tm.tm_mday || !logfile) { /* on dois ouvrir un nouveau fichier log */
	char bufname[1024];
	/* On est pas sur que le fichier ai dj t ouvert une fois
	 * donc on verifis a avant d'essayer de le fermer
	 * ce qui evite un segfault par la meme occasion:)
	 */
	if (logfile)
	    fclose(logfile);
	lastdaylog=tm.tm_mday;
	strftime(buftime, sizeof(buftime)-1, "%Y%d%b", &tm);
	sprintf(bufname, "%s%s/%s.%s", DataDirectory ? DataDirectory : "", LOG_REP, LOG_FILE_PREFIX, buftime);
	if (!(logfile = fopen(bufname, "a"))) {
	    printf("ERROR: Cannot open log file '%s' for create/append\n", bufname);
	    lastdaylog=-1;
	    va_end(ap);
	    return 0;
	}
	log("Now logging in '%s'...", bufname);
    }
    strftime(buftime, sizeof(buf)-1, "[%b %d %H:%M:%S %Y] ", &tm);
    fputs(buftime, logfile);
    fputs(buf, logfile);
    fflush(logfile);
    va_end (ap);
    return 1;
}

/* Termine la session log (06/11/99)
 */

void close_log()
{
    time_t t;
    struct tm tm;
    char buftime[256], buf[512];

    time(&t);
    tm = *localtime(&t);

    strftime(buftime, sizeof(buf)-1, "[%b %d %H:%M:%S %Y] ", &tm);
    fputs(buftime, logfile);
    fputs("Log closed\n", logfile);
    fclose(logfile);
}
