/* FlyStats! is copyright (c) 1999-2000 CRESTO Sylvain <tost>.
 * E-mail: <tost@softhome.net>
 * Contact: #flystats on irc.kewl.org
 *
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 */

#include "extern.h"

int serversock, quitflystats, lastday = 0, tolerance = 0;
char *RemoteServerIp;   /* IP du serveur remote si il peu tre resolve sinon NULL */
char *DataDirectory = NULL;	/* Repertoire contenant les donnes (NULL si c'est le repertoire courant) */
time_t runsince;
struct tm runsince_tm;
int prenofork = 0, nofork = 1, statrun = 0 /* 1 si le statserv est connect */
#ifdef ALLOW_DEBUG
	, debug = 0
#endif
	;

void main_loop()
{
    char buf[512], *source = NULL, **servcmd;
    Message *servmessage;
    int result, c, lasttime = 0;
    time_t lastcurtime = time(NULL), curtime, lastpingsent = time(NULL) - PingServerTime + 30,
	laststat = time(NULL) - UpdateStatTime + 30, lastlusers = time(NULL) - UpdateChanStatTime + 30;
    struct tm tm;

    do {
	quitflystats = 0;
	while (!quitflystats) {
	    curtime = time(NULL);
	    if (curtime < lastcurtime) {
		/* detection d'un mauvais rereglage de l'horloge */
		SockWrite(":%s %s :WARNING! Clock skrew detected!", ServerName, WALLOPS);
		log("Clock skrew detected!!");
	    }
	    lastcurtime = curtime;
	    tm = *localtime(&curtime);
	    if (lastpingsent < curtime - PingServerTime) {
		/* ping les serveurs */
		ping_server(servmap);
		lastpingsent = curtime;
	    }
	    if (laststat < curtime - UpdateStatTime) {
		/* stats sur le nombre d'utilisateur */
		int timepos;

		if (tm.tm_hour >= 18) {
		    timepos = 3;
		} else if (tm.tm_hour >= 12) {
		    timepos = 2;
		} else if (tm.tm_hour >= 6) {
		    timepos = 1;
		} else {
		    timepos = 0;
		}
		update_domain_stats(timepos, lasttime!=timepos);
		update_server_stats(servmap, timepos, lasttime!=timepos);
		update_net_stats(timepos, lasttime!=timepos);
		laststat = curtime;
		lasttime = timepos;
	    }
	    if (lastlusers < curtime - UpdateChanStatTime && RemoteName) {
		/* envois un LUSERS pour les stats sur le nombre de chan */
		SockWrite(":%s LUSERS %s", ssNick, RemoteName);
		lastlusers = curtime;
	    }
	    if (lastday != tm.tm_mday) {
		/* changement de jour detect */
		lastday = tm.tm_mday;
		dailymaxusercount = usercount + invusercount;
		dailykillcount = dailyservkillcount = dailysplitcount = dailytotalusercount = 0;
		dailymaxchannelcount = channelcount;
		dailymaxusertime = dailymaxchanneltime = curtime;
	    }
	    result=SockRead(buf, serversock);

	    if (*buf<32)
		continue;

#ifdef ALLOW_DEBUG
	    if (debug)
		log("Received '%s'", buf);
#endif
	    if (!(c = split_buf(buf, &source, &servcmd))) {
		SockWrite("GLOBAL :Received incomplete commande from server");
		log("Received incomplete command from server (:%s)", source);
	    } else {
		/* message du serveur */
		if ((servmessage = find_message(servcmd[0]))) {
		    if (servmessage->func)
			servmessage->func(source, c, servcmd);
		}
	    }
	    free(servcmd);

#ifdef USETHREAD
	    /* gere les proxy-scan */
	    do_proxycheck();
#endif
	}

	switch (quitflystats) {
	   case 2:
	   case 12:
	     if (quitflystats == 2) {
		log("Got signal SIGHUP, reloading stats conf. file...");
		SockWrite(":%s %s :Got signal SIGHUP, reloading stats conf. file", ServerName, WALLOPS);
	     }
#ifndef IRC_UNREAL
		/* sous Unreal on peu modifier l'user@host/realname sans deconnection de l'utilisateur */
	     quit_client(NULL, "Come back in few");
#endif
	     if (!load_config()) {
		SockWrite(":%s %s :Stats conf. file is invalid! Please check logs and reload a good one",
			ServerName, WALLOPS);
	     } else {
		log("Rehash done");
	     }
#ifndef IRC_UNREAL
	     connect_client(NULL);
#else
	     update_client(NULL);
#endif
	     break;
#ifndef LINUX20
	   case 3:
	     log("Got signal SIGUSR1, restarting StatServ...");
	     SockWrite(":%s %s :Got signal SIGUSR1, StatServ restarting...", ServerName, WALLOPS);
#endif
	   case 13:
	     SockWrite("SQUIT %s :StatServ restarting...", ServerName);
	     break;
	   case 4:
	     log("Got signal SIGTERM, StatServ terminating...");
	     SockWrite(":%s %s :Got signal SIGTERM, StatServ terminating...", ServerName, WALLOPS);
	   case 14:
	     SockWrite("SQUIT %s :StatServ terminating...", ServerName);
	     break;
#ifndef LINUX20
           case 5:
	     log("Got signal SIGUSR2, Changing server...");
	     quit_client(NULL, "Changing server...");
	     SockWrite(":%s %s :Got signal SIGUSR2, Changing server...", ServerName, WALLOPS);
	     SockWrite("SQUIT %s :Changing server on SIGUSR2", ServerName);
	     break;
#endif
	}
    } while (quitflystats==2 || quitflystats==12);
}

/* (re)connecter le StatServ */
void connect_client(char *client)
{
#ifdef IRC_BAHAMUT
    SockWrite("NICK %s 1 %ld +%s %s %s %s 0 :%s", ssNick, time(NULL), SS_MODE, ssUser,
		ssHost, ServerName, ssRealName);
#elif defined(IRC_UNDERNET)
    SockWrite("%c NICK %s 1 %ld %s %s +%s %s %cAA :%s", yxx[0], ssNick, time(NULL), ssUser,
		ssHost, SS_MODE, ip_buf, yxx[0], ssRealName);
    if (!client) {
	SockWrite("%c END_OF_BURST", yxx[0]);
	SockWrite("%c EOB_ACK", yxx[0]);
    }
#else
    SockWrite("NICK %s 1 %ld %s %s %s 0 :%s", ssNick, time(NULL), ssUser,
		ssHost, ServerName, ssRealName);
    SockWrite(":%s MODE %s +%s", ssNick, ssNick, SS_MODE);
#endif
}

#ifdef IRC_UNREAL
/* Mets  jour les infos d'un client sans deconnection
 * user@host / realname
 */
void update_client(char *client)
{
    if (ssUser && strcmp(ssUser, bakssUser))
	SockWrite(":%s SETIDENT %s", ssNick, ssUser);
    if (ssHost && strcmp(ssHost, bakssHost))
	SockWrite(":%s SETHOST %s", ssNick, ssHost);
    if (ssRealName && strcmp(ssRealName, bakssRealName))
	SockWrite(":%s SETNAME :%s", ssNick, ssRealName);
    if (ServerDesc && strcmp(ServerDesc, bakServerDesc))
	SockWrite(":%s SDESC :%s", ssNick, ServerDesc);
    free(bakssNick);
    free(bakssUser);
    free(bakssHost);
    free(bakssRealName);
    free(bakServerDesc);
}
#endif

/* renvois 1 si c'est le nick d'un des pseudo client */
int pseudo_client(char *nick)
{
    return (!strcasecmp(nick, ssNick));
}

/* Faire quitter les pseudo clients (ou un en particulier) */
void quit_client(char *client, char *reason)
{
    SockWrite(":%s QUIT :%s", ssNick, reason);
}

int parse_param(int argc, char *argv[])
{
    int i;

    for (i=1; i<argc; i++) {
	if (!strcmp(argv[i], "-help") || !strcmp(argv[i], "--help")) {
	    show_help(argv[0]);
	    return 0;
	} else if (!strcmp(argv[i], "-about")) {
	    do_copyright();
	    return 0;
	} else if (!strcmp(argv[i], "-debug")) {
#ifdef ALLOW_DEBUG
	    debug = 1;
#else
	    printf("-debug not allowed. You must recompile FlyStats with ALLOW_DEBUG.\n");
	    return 0;
#endif
	} else if (!strcmp(argv[i], "-tolerance")) {
	    tolerance = 1;
	} else if (!strcmp(argv[i], "-nofork")) {
	    prenofork = 1;
	} else if (!strcmp(argv[i], "-data")) {
	    if (++i < argc) {
		int c;
		DataDirectory = malloc((c = strlen(argv[i])) + 1);
		memcpy(DataDirectory, argv[i], c + 1);
		if (argv[i][c - 1]!='/') {
		    DataDirectory = realloc(DataDirectory, c + 2);
		    strcat(DataDirectory, "/");
		}
	    } else {
		printf("ERROR: Syntax: -data <directory>\nDirectory is a string.\n");
		return 0;
	    }
	} else if (!strcmp(argv[i], "-info")) {
	    do_info();
	    return 0;
	} else if (!strcmp(argv[i], "-version")) {
		/* La version est affich automatiquement au demarrage
		 * on a donc rien  faire :)
		 */
	    return 0;
	} else {
	    printf("ERROR: Invalid option '%s'\nTry '%s --help' for more information.\n", argv[i], argv[0]);
	    return 0;
	}
    }
    return 1;
}

/* Es ce qu'on doit changer de serveur ?
 * Si le fichier temporraire existe oui, dans ce cas on l'efface
 * sinon non dans ce cas on ne fais rien :)
 */
int ChangeServer()
{
    char buf[1024];
    FILE *fp;

    sprintf(buf, "%s%s", DataDirectory ? DataDirectory : "", TMP_FILE);
    if ((fp=fopen(buf, "r"))) {
#ifdef ALLOW_DEBUG
	if (debug)
	    log("Found '%s' file", buf);
#endif
	fclose(fp);
	if (remove(buf)==-1)
	    log("Failed to delete '%s' file", buf);
	return 1;
    };
    return 0;
}

int main(int argc, char **argv, char **envp)
{
    int chserveur;

    printf("FlyStats%s (%s)\n", flystats, flyname);
    if (argc>1) {
	if (!parse_param(argc, argv))
	    return 1;
    }
    do_flyflags();
    log("Log started");

    if (!load_config())
	return 1;
    load_lang();

    if (!prenofork) {
	FILE *fp;
	int i = fork();
	nofork = 0;
	if (i) {
	    char *buf = malloc(1024);
	    sprintf(buf, "%s%s", DataDirectory ? DataDirectory : "", PID_FILE);
	    if ((fp = fopen(buf, "w"))) {
		fprintf(fp, "%i", i);
		fclose(fp);
	    } else log("Failed to write '%s' file, FLyStats! terminating... :(", buf);
	    free(buf);
	    return 0;
	}
    }

	/* Gestion de SIGUSR1, SIGUSR2, SIGTERM et SIGHUP
	 */
    setsignal();

	/* Initialise les variables
	 */
    memset(netaveragetotal, 0, 5);
    memset(netaveragecount, 0, 5);
    memset(netaverage, 0, 5);

	/* On connecte au serveur */
    chserveur=ChangeServer();
    do {
	if (chserveur) {
	    sleep(SleepBeforeReconnect);
	    UsedRemoteServer = UsedRemoteServer->next;
#ifdef ALLOW_DEBUG
	    if (debug)
		log("Next server is '%s', using it", UsedRemoteServer->name);
#endif
	}
	if (ConnectFlyStats()!=-1)
	    break;
	log("Cannot connect to remote server");
	if (!chserveur)
	    sleep(SleepBeforeReconnect);
    } while (1);

    statrun = 1;
 
    do {

#ifdef IRC_BAHAMUT
	SockWrite("PASS %s :TS", UsedRemoteServer->pass);
	SockWrite("CAPAB TS3 SSJOIN");
#else
	SockWrite("PASS %s", UsedRemoteServer->pass);
#endif
#ifdef IRC_UNDERNET
	yxx[0] = convert2y[ServerNumeric];
	inttobase64(&yxx[1], 255, 2);
	SockWrite("SERVER %s 1 %lu %lu J10 %s :%s", ServerName, time(NULL), time(NULL), yxx, ServerDesc);
	sprintf(SERV, ":%s ", ServerName);
#else
	SockWrite("SERVER %s 1 :%s", ServerName, ServerDesc);
	*SERV = 0;
#endif

#ifdef IRC_BAHAMUT
	SockWrite("SVINFO 3 1 0 :%lu", time(NULL));
#elif defined(IRC_UNREAL)
	SockWrite("PROTOCTL TOKEN");
	SockWrite("NETINFO 1 %lu %d 0 0 0 0 :%s", time(NULL), UNREAL_PROTOCOL, IrcNetwork);
#endif
	runsince = time(NULL);
	runsince_tm = *localtime(&runsince);
	connect_client(NULL);

	main_loop();
	log("Closing connection...");
	/* Pour ne pas quitter en Connection reset by peer */
	shutdown(serversock, 2);
        close(serversock);

        /* quitflystats
	 * 1 = ERROR ou SQUIT
	 * 2 = SIGHUP (rehash)
	 * 3 = SIGUSR1 (restart)        !!
	 * 4 = SIGTERM                  !!
	 * 5 = SIGUSR2 (change serveur)
	 * 12 = REHASH
	 * 13 = RESTART                 !!
	 * 14 = SHUTDOWN                !!
	 */
    } while (quitflystats==2 || quitflystats==12);
    close_log();
    if (quitflystats!=4 && quitflystats!=14) {
	/* Les FlyStats doivent tre relancs
	 * RESTART, ERROR, SQUIT, SIGUSR1 ou SIGUSR2
	 */
	if (quitflystats==1 || quitflystats==5) {
	    /* On changera de serveur au prochain connect */
	    FILE *fp;
            char *buf = malloc(1024);
	    sprintf(buf, "%s%s", DataDirectory ? DataDirectory : "", TMP_FILE);
#ifdef ALLOW_DEBUG
	    if (debug)
		log("Create '%s' file", buf);
#endif
            if ((fp = fopen(buf, "w"))) {
		fputs("* FlyStats! * Do not remove this file", fp);
		fclose(fp);
	    } else printf("%s: Failed to write '%s' file, FlyStats terminating... :(", argv[0], buf);
	    free(buf);
	}
	execve(argv[0], argv, envp);
    }
    return 0;
}
