/* FlyStats! is copyright (c) 1999-2000 CRESTO Sylvain <tost>.
 * E-mail: <tost@softhome.net>
 * Contact: #flystats on irc.kewl.org
 *
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 */

#include "extern.h"

Command *CommandsBuf = NULL;
Command *LastBuf = NULL;
char SERV[256];

static void m_admin(char *source, int c, char **cmd)
{
    SockWrite("%s256 %s :Administrative info about %s", SERV, source, ServerName);
    SockWrite("%s257 %s :The FlyStats version %s", SERV, source, flystats);
    SockWrite("%s258 %s :%s", SERV, source, AdminInfo);
    SockWrite("%s259 %s :Please report all bugs to tost@softhome.net", SERV, source);
}

static void m_error(char *source, int c, char **cmd)
{
    log("Received %s %s: StatServ terminating...", cmd[0], cmd[1]);
    quitflystats = 1;
}

/* demande d'aide avec les helpops */
static void m_help(char *source, int c, char **cmd)
{
    User *u = finduser(source);
    if (!u) {
	log("Received HELP from unknown user '%s'", source);
	return;
    }

    if (!OperOnly || (u->mode & UMODE_O)) {
	if (!strcasecmp(cmd[1], ssNick)) {
	    char buf[512];
	    int i;

	    strcpy(buf, "HELP");
	    for (i=2; i<c; i++) {
		strcat(buf, " ");
		strcat(buf, cmd[i]);
	    }
	    do_ss_helpops(u, buf);
	}
    }
}

static void m_info(char *source, int c, char **cmd)
{
    SockWrite("%s371 %s : \2FlyStats\2 version %s (%s)", SERV, source, flystats, flyname);
    SockWrite("%s371 %s :", SERV, source);
    SockWrite("%s371 %s :FlyStats! is copyright (c) 1999-2000 CRESTO Sylvain <tost>", SERV, source);
    SockWrite("%s371 %s :+ Configuration file information written by lara <lara-irc@ifrance.com>.", SERV, source);
    SockWrite("%s371 %s :+ Dutch translation written by Melle Visser <Headbang> irc.silverserver.nu.", SERV, source);
    SockWrite("%s371 %s :", SERV, source);
    SockWrite("%s371 %s :The latest version of FlyStats can always be obtained at http://www.multimania.com/tost/flystats/",
	SERV, source);
    SockWrite("%s371 %s :Please report all bugs, comments, suggestions to <tost@softhome.net>", SERV, source);
    SockWrite("%s374 %s :End of /INFO list", SERV, source);
}

static void m_mode(char *source, int c, char **cmd)
{
    if (*cmd[1]>64) {
	/* MODE sur un user */
	do_umode(cmd[1], cmd[2]);
    }
}

static void m_motd(char *source, int c, char **cmd)
{
    /* Look people. I'm not asking for payment, praise, or anything like
     * that for using Flystats, so at least I would like to get some
     * recognition for my works. So please be nice, and don't remove the
     * copyright message below.
     * CRESTO Sylvain <tost> tost@softhome.net
     */
    SockWrite("%s375 %s :- %s Message of the day - ", SERV, source ,ServerName);
    SockWrite("%s372 %s :- \2FlyStats\2 version %s (%s)", SERV, source, flystats, flyname);
    SockWrite("%s372 %s :-", SERV, source);
    SockWrite("%s372 %s :- FlyStats is copyright (c) 1999-2000 CRESTO S. <tost>", SERV, source);
    SockWrite("%s372 %s :- FlyStats is copyright (c) 1999-2000 CRESTO Sylvain <tost@softhome.net>", SERV, source);
    SockWrite("%s372 %s :- + Configuration file information written by lara <lara-irc@ifrance.com>.", SERV, source);
    SockWrite("%s372 %s :- + Dutch translation written by Melle Visser <Headbang> irc.silverserver.nu.", SERV, source);
    SockWrite("%s372 %s :-", SERV, source);
    SockWrite("%s372 %s :- The latest version of FlyStats can always be obtained at http://www.multimania.com/tost/flystats/",
	SERV, source);
    SockWrite("%s372 %s :- Please report all bugs, comments, suggestions to <tost@softhome.net>", SERV, source);
    SockWrite("%s376 %s :End of /MOTD command", SERV, source);
}

/* repond au ping du serveur (11/11/99)
 */
static void m_ping(char *source, int c, char **cmd)
{
     SockWrite("PONG :%s", cmd[1]);
}

static void m_pong(char *source, int c, char **cmd)
{
    do_pong(source);
}

/* reconnecte les clients en cas de kill (vive les ircop neuneux) (13/11/99)
 * et mets a jour les stats de kill
 */
static void m_kill(char *source, int c, char **cmd)
{
#ifndef IRC_UNREAL
    if (!pseudo_client(cmd[1])) {
#endif
	/* mets  jour les stats de kill */
	User *user = finduser(cmd[1]);

	if (!user) {
	    log("Received KILL for unknown user '%s'", cmd[1]);
	} else if (user->server) {
	    if (!strchr(source, '.')) {
		/* kill venant d'un user */
		User *userfrom = finduser(source);
		if (userfrom && userfrom->server && !IgnoreServer(userfrom->server)) {
		    user->server->killcount++;
		    totalkillcount++;
		    dailykillcount++;
		}
	    } else {
		/* kill venant d'un serveur */
		Server *server = find_server(servmap, source);
		if (server && !IgnoreServer(server)) {
		    user->server->servkillcount++;
		    totalservkillcount++;
		    dailyservkillcount++;
		}
	    }
	    do_quit(cmd[1], cmd[2]);
	}
#ifndef IRC_UNREAL
    } else {
	connect_client(cmd[1]);
	log("Received KILL for %s (%s) from %s", cmd[1], cmd[2], source);
	SockWrite("%s :Reiceved \2KILL\2 for Services %s from \2%s\2", WALLOPS, cmd[1], source);
    }
#endif
}

static void m_lusers(char *source, int c, char **cmd)
{
#ifdef IRC_UNDERNET
    User *u = finduser(source);
#endif
    SockWrite("%s251 %s :There are %d users and %d invisible on %d servers", SERV, source, 0, 0, servernum);
    SockWrite("%s252 %s %d :operator(s) online", SERV, source, 0);
    SockWrite("%s254 %s %d :channels formed", SERV, source, 0);
    SockWrite("%s255 %s :I have %d clients and %d servers", SERV, source, 0, 0);
#ifdef IRC_UNDERNET
    if (u)
	SockWrite("%c NOTICE %s :Highest connection count: %d (%d clients)", yxx[0], u->yxx, maxusercount+1, maxusercount);
#else
    SockWrite("265 %s :Current local users: %d  Max: %d", source, 1, 1);
    SockWrite("266 %s :Current global users: %d  Max: %d", source, usercount + invusercount, maxusercount);
#endif
}

/* nouveau utilisateur ou changement de nick */
static void m_nick(char *source, int c, char **cmd)
{
    if (!source || strchr(source, '.')
#ifdef IRC_UNDERNET
	|| (!source[1])
#endif
		) {
	char **data = malloc(sizeof(char *) * 5);

	User *u;
	/* nouveau user
	 * 0 - nick
	 * 1 - username
	 * 2 - hostname
	 * 3 - servername (yxx avec l'ircu 2.10.*)
	 * 4 - signon
	 */
	data[0] = cmd[1];
#ifdef IRC_BAHAMUT
	data[1] = cmd[5];
	data[2] = cmd[6];
	data[3] = cmd[7];
#else
	data[1] = cmd[4];
	data[2] = cmd[5];
# ifdef IRC_UNDERNET
	data[3] = cmd[c-2];
# else
	data[3] = cmd[6];
# endif
#endif
	data[4] = cmd[3];
	u = do_newnick(data);
	free(data);

	/* parse les umodes passs dans la commande NICK de bahamut et ircu 2.10.* */
#ifdef IRC_BAHAMUT
	if (cmd[4][1])
	    do_umode(cmd[1], cmd[4]);
#else
# ifdef IRC_UNDERNET
	if (*cmd[6]=='+')
	    do_umode(cmd[1], cmd[6]);
# endif
#endif

#ifdef USETHREAD
	/* Ajouter  la liste de verification des proxy */
	if (ScanForProxy && ScanForWhat) {
	    if (firstproxycheckuser) {	
		lastproxycheckuser->proxy_next = u;
		u->proxy_prev = lastproxycheckuser;
	    } firstproxycheckuser = u;
	    lastproxycheckuser = u;
	}
#endif
    } else {
	/* changement de nick */
	do_changenick(source, cmd[1]);
    }
}

/* Rception d'un message */
static void m_privmsg(char *source, int c, char **cmd)
{
    /* Pour le moment il n'y a qu'un pseudo client de connect: StatServ
     * donc c forcement pour lui:)
     */
    do_statserv(source, c-2, cmd[2]);
}

/* reception d'un QUIT */
static void m_quit(char *source, int c, char **cmd)
{
    do_quit(source, cmd[1]);
}

/* connection d'un nouveau serveur (11/11/99)
 */
static void m_server(char *source, int c, char **cmd)
{
    do_server(source, c, cmd);
}

static void m_squit(char *source, int c, char **cmd)
{
    do_squit(cmd[1]);
}

static void m_stats(char *source, int ac, char **av)
{
    int i;
    User *u;
    RemoteServer *rs;
    switch(*av[1]) {
      case 'u':
	i = time(NULL) - runsince;
	SockWrite("%s242 %s :Server Up %d days, %d:%02d:%02d", SERV,
		source, i/86400, (i/3600) % 24, (i/60) % 60, i % 60);
	break;
      case 'o':
      case 'O':
	if (opercount)
	for (i=0; i<opercount; i++) {
	    if ((u = finduser(operlist[i])))
		SockWrite("%s243 %s O%s %s@%s * %s", SERV, source, u->flags, u->username, u->host, operlist[i]);
	}
	break;
      case 'C':
      case 'c':
	for (rs = FirstRemoteServer; rs; rs = rs->next) {
	    SockWrite("%s213 %s C * * %s %d 0", SERV, source, rs->name, rs->port);
	    SockWrite("%s213 %s N * * %s %d 0", SERV, source, rs->name, rs->port);
	    if (rs == FirstRemoteServer)
		break;
	}
	break;
      case 'M':
      case 'm':
	SockWrite("%s212 %s DOMAIN %d 0", SERV, source, ss_domaincount);
	SockWrite("%s212 %s HELP %d 0", SERV, source, ss_helpcount);
	SockWrite("%s212 %s IDENTIFY %d 0", SERV, source, ss_identifycount);
	SockWrite("%s212 %s LANGUAGE %d 0", SERV, source, ss_languagecount);
	SockWrite("%s212 %s MAP %d 0", SERV, source, ss_mapcount);
	SockWrite("%s212 %s NETSTATS %d 0", SERV, source, ss_netstatscount);
	SockWrite("%s212 %s OPERLIST %d 0", SERV, source, ss_operlistcount);
	SockWrite("%s212 %s REHASHCOUNT %d 0", SERV, source, ss_rehashcount);
	SockWrite("%s212 %s REMOVESERVER %d 0", SERV, source, ss_removeservercount);
	SockWrite("%s212 %s SERVERS %d 0", SERV, source, ss_serverscount);
	SockWrite("%s212 %s SERVER %d 0", SERV, source, ss_servercount);
	break;
      default :
	*av[1]='*';
    }
    SockWrite("%s219 %s %c :End of /STATS report.", SERV, source, *av[1]);
}

static void m_time(char *source, int ac, char **av)
{
    time_t t = time(NULL);
    struct tm *tm = localtime(&t);
    char buf[256];

    strftime(buf, sizeof(buf), "%A %B %d %Y -- %H:%M %z", tm);
    SockWrite("%s391 %s :%s", SERV, source, buf);
}

static void m_version(char *source, int c, char **cmd)
{
#ifndef IRC_UNREAL
    SockWrite("%s351 %s FlyStats%s (%s) :%s %s", SERV, source, flystats, flyname, ServerName, flyflags);
#else
    SockWrite(":%s 351 %s FlyStats%s(%s)(%s).%s %s :[*=%d]", ServerName, source, flystats, flyname, IrcNetwork,
		flyflags, ServerName, UNREAL_PROTOCOL);
#endif
}

static void m_whois(char *source, int c, char **cmd)
{
    SockWrite("%s311 %s %s %s %s * :Remote whois is not supported by StatServ", SERV, source, ssNick,
	ssUser, ssHost);
    SockWrite("%s318 %s :End of /WHOIS list", SERV, source); 
}

/* Mets  jour le nombre de channel */
static void m_254(char *source, int c, char **cmd)
{
    channelcount = atol(cmd[2]);
    if (channelcount > maxchannelcount) {
	maxchannelcount = channelcount;
	maxchanneltime = time(NULL);
    }
    if (channelcount > dailymaxchannelcount) {
	dailymaxchannelcount = channelcount;
	dailymaxchanneltime = time(NULL);
    }
}

/* Mets  jour la version des servers */
static void m_351(char *source, int c, char **cmd)
{
    char version[512];
    Server *server = find_server(servmap, source);

    if (server) {
	sprintf(version, "%s %s", cmd[2], cmd[4]);
	server->version = strdup(version);
    } else {
	log("Received message 351 from unknown server %s", source);
    }
}

static void m_402(char *source, int c, char **cmd)
{
    log("%s :No such server", source);
}

#ifdef IRC_UNREAL
/* Sous Unreal les opers peuvent changer l'host des autres users */
static void m_chghost(char *source, int c, char **cmd)
{
    if (!strcasecmp(ssNick, cmd[1])) {
	log("Received '%s CHGHOST %s' from '%s', host updated", ssNick, cmd[2], source);
	SockWrite(":%s GLOBOPS :%s used 'CHGHOST %s %s'", ServerName, source, cmd[1], cmd[2]);
	free(ssHost);
	ssHost = strdup(cmd[2]);
    }
}
#endif

Message messages[] = {
    { "ADMIN",		m_admin },
    { "ERROR",		m_error },
    { "HELP",		m_help },
    { "INFO",		m_info },
    { "KILL",		m_kill },
    { "LUSERS",		m_lusers },
    { "MODE",		m_mode },
    { "MOTD",		m_motd },
    { "NICK",		m_nick },
    { "PING",		m_ping },
    { "PONG",		m_pong },
    { "PRIVMSG",	m_privmsg },
    { "QUIT",		m_quit },
    { "SERVER",		m_server },
    { "SQUIT",		m_squit },
    { "STATS",		m_stats },
    { "TIME",		m_time },
    { "VERSION",	m_version },
    { "WHOIS",		m_whois },
    { "254",		m_254 },	/* LUSERS chan reply */
    { "351",		m_351 },	/* VERSION reply */
    { "402",		m_402 },	/* debug: No such server */
#ifdef IRC_UNREAL
    { "G",		m_mode },
    { "&",		m_nick },
    { "'",		m_server },
    { "CHGHOST",	m_chghost },
#endif
    { NULL }
};

Message *find_message(char *name)
{
    Message *m;

    for (m = messages; m->cmd; m++) {
	if (!strcmp(name, m->cmd))
	    return m;
    }
    return NULL;
}

/* reponds aux ctcp: PING, VERSION...
 */

void ctcp_reply(char *source, char *dest, char *cmd)
{
#ifdef IRC_UNDERNET
    User *u = finduser(source);
    if (!u)
	return;
#endif
    if (!strcmp(cmd, "\1PING")) {
	char *s = strtok(NULL, "");
	if (!s)
	    s = "\1";
	SockWrite(":%s NOTICE %s :\1PING %s", dest,
#ifdef IRC_UNDERNET
	u->yxx,
#else
	source,
#endif
	s);
    } else if (!strcmp(cmd, "\1VERSION\1")) {
	SockWrite(":%s NOTICE %s :\1VERSION FlyStats version %s (%s) -- by tost %chttp://www.multimania.com/tost/flystats/%c\1",
		dest,
#ifdef IRC_UNDERNET
	u->yxx,
#else
	source,
#endif
	flystats, flyname, 31, 31);
    }
}
