/* FlyStats! is copyright (c) 1999-2000 CRESTO Sylvain <tost>.
 * E-mail: <tost@softhome.net>
 * Contact: #flystats on irc.kewl.org
 *
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 */

#include "extern.h"

int servernum = 1, servercount = 1, dailysplitcount = 0, dailyservkillcount = 0, maxservercount = 1;
long splitcount = 0, totalservkillcount = 0;
time_t timemaxservercount;
long netaveragetotal[4];
long netaveragecount[4];
long netaverage[4];
int actualsplit = 0;	/* Nombre de server actuelement split */
int showallservercount;

Server *flystat;	/* Server flystat dans la map */

char *RemoteName = NULL;
Server *servmap = NULL;
#ifdef IRC_UNDERNET
char yxx[4];	/* voir les sources de l'ircu pour plus d'info sur yxx */
#endif

void add_server_ping(Server *server);
int get_lag(Server *server);
char *string_lag(Server *server, char *buf);

void show_server(char *source, User *u, Server *server, char *view)
{
    Server *serv;
    char buf[512]="", lag[150];

    if (server->pos) {
	int i;
	view[server->pos-1]=1;	
	for (i=0; i<server->pos; i++)
	    strcat(buf, view[i] ? "| " : "  ");
	buf[strlen(buf)-1]='-';
    }

    for (serv = server; serv; serv = serv->next) {
	if (!serv->next && server->pos) {
	    buf[server->pos*2-2]='`';
	    view[server->pos-1]=0;
	}
	*lag = 0;
	if (serv->connected==1) {
	    int lagtime = get_lag(serv);
	    if (lagtime > ServerLagTime)
		sprintf(lag, "\2  (lag %d)", lagtime < 1000 ? lagtime : 999);
	} else if (!serv->connected) {
	    sprintf(lag, "\2  (%s", getstring(u, STAT_SPLIT));
	    *(strchr(lag, '\r')) = ')';
	}
	SockWrite(":%s NOTICE %s :%s%s%s%s", source, nickyxx(u),
		buf, *lag ? "\2" : "", serv->name, *lag ? lag : "");
        if (serv->leaf)
	    show_server(source, u, serv->leaf, view);
    }
}

int get_lag(Server *server)
{
    if (server->connected!=1) {
	return -1;
    } else {
	int i = time(NULL) - server->sendlastping;
	return server->pingcount==server->pongcount || i < server->lag ? server->lag : i;
    }
}

char *string_lag(Server *server, char *buf)
{
    int i;
    switch (server->connected) {
      case 0:
	strcpy(buf, "SPLIT");
	break;
      case 1:
	i = time(NULL) - server->sendlastping;
	if (server->pingcount==server->pongcount || i <= server->lag) {
	    sprintf(buf, "LAG %ds", server->lag < 1000 ? server->lag : 999);
	} else {
	    sprintf(buf, "Waiting for PONG since %ds", i);
	}
	break;
      default:
	strcpy(buf, "XX");
    }
    return buf;
}

int show_all_servers(char *source, User *u, Server *server, char *mask)
{
    Server *serv;
    char buf[512], buflag[150];
    int c = 0;

    for (serv = server; serv; serv = serv->next) {
	showallservercount++;
	if (!mask || match_wild_nocase(mask, serv->name)) {
	    sprintf(buf, "%-3d%s (%s) %s", showallservercount, serv->name, string_lag(serv, buflag),
										serv->version ? serv->version : "(XX)");
	    SockWrite(":%s NOTICE %s :%s", source, nickyxx(u), buf);
	    c = 1;
	}
	if (serv->leaf) {
	    if (show_all_servers(source, u, serv->leaf, mask))
		c = 1;
	}
    }
    return c;
}

Server *find_server(Server *server, char *name)
{
    Server *serv, *servhub;

    for (serv = server; serv; serv = serv->next) {
	if (!strcasecmp(serv->name, name))
	    return serv;
	if (serv->leaf && (servhub = find_server(serv->leaf, name)))
	    return servhub;
    }
    return NULL;
}

#ifdef IRC_UNDERNET
Server *find_server_yxx(Server *server, char name)
{
    Server *serv, *servhub;

    for (serv = server; serv; serv = serv->next) {
        if (serv->yxx[0]==name)
            return serv;
        if (serv->leaf && (servhub = find_server_yxx(serv->leaf, name)))
            return servhub;
    }
    return NULL;
}
#endif

Server *find_server_match(Server *server, char *name)
{
    Server *serv, *servhub;

    for (serv = server; serv; serv = serv->next) {
        if (match_wild_nocase(name, serv->name))
            return serv;
        if (serv->leaf && (servhub = find_server_match(serv->leaf, name)))
            return servhub;
    }
    return NULL;
}

/* Initialise le server flystats
 * a ne retourne rien vu que le serveur est contenue dans la variable global "flystat"
 * Aprs il faut bien entendu le placer dans la map :)
 */
void init_flystat_server()
{
    flystat = calloc(sizeof(Server), 1);
    flystat->name = strdup(ServerName);
    flystat->desc = strdup(ServerDesc);
    flystat->version = malloc(strlen(flystats) + 50);
    sprintf(flystat->version, "FlyStats%s %s", flystats, flyflags);
    flystat->pos = 1;
    flystat->connected = 2;
}

/* Efface un server de la map
 * - ne vire pas les leaf (utiliser remove_server_leaf pour a)
 * - ne vire pas les users (utiliser remove_server_users pour a)
 */
void remove_one_server(Server *server)
{
    if (server->next)
	server->next->prev = server->prev;
    if (server->prev) {
	server->prev->next = server->next;
    } else {
	server->hub->leaf = server->next;
    }
    free(server->name);
    free(server->remote);
    free(server->desc);
    if (server->version)
	free(server->version);
    free(server);
    actualsplit--;
    servernum--;
}

/* Traite une commande SERVER
 * Bon va falloir bien tester tout a !:)
 * --> Toute la gestion du changement d'hub de statserv est a virer,
 *     vu que le statserv se relance dans ce cas l maintenant
 */
int do_server(char *source, int c, char **cmd)
{
    Server *oneserver;
    log("Received SERVER from '%s'", cmd[1]);

    servercount++;
    if (servercount > maxservercount) {
	maxservercount = servercount;
	timemaxservercount = time(NULL);
    }
    if ((oneserver = find_server(servmap, cmd[1]))) {
	/* retour d'un server split */
#ifdef ALLOW_DEBUG
	if (debug)
	    log("Server %s is coming back...", cmd[1]);
#endif
	actualsplit--;
	if (oneserver->version) {	/* mets  jour la version et la description au cas */
	    free(oneserver->version);	/* ou l'ircd ai chang */
	    oneserver->version = NULL;
	}
	if (oneserver->desc) {
	    free(oneserver->desc);
	    oneserver->desc = NULL;
	}
	oneserver->desc = strdup(cmd[c-1]);
	/* Attention source peu tre NULL si les flystats se reconnecte apres
	 * un message ERROR, dans ce cas l leur serveur hub est un serveur
	 * qui existait dans la map (vu que le findserver != NULL)
	 * Voir plus bas pour la gestion d'un nouveau hub inexistant
	 */
	if (!source || strcasecmp(source, oneserver->hub->name)) {
	    Server *last,
#ifdef IRC_UNDERNET
		*servhub = source ? find_server_yxx(servmap, source[0]) : NULL;
#else
		*servhub = source ? find_server(servmap, source) : NULL;
#endif
	    /* enlve l'ancien serveur */
	    if (oneserver->next)
		oneserver->next->prev = oneserver->prev;
	    if (oneserver->prev) {
		oneserver->prev->next = oneserver->next;
	    } else if (oneserver->hub) {
		/* oneserver->hub est NULL si statserv se reconnecte au mme hub */
		oneserver->hub->leaf = oneserver->next;
	    } else if (servmap == oneserver) {
		servmap = oneserver->next;
	    } else log("Bogus server map, server '%s'->hub == NULL but server != servmap", oneserver->name);
	    oneserver->next = oneserver->prev = NULL;

	    if (source) {
		/* Retour d'un serveur non hub de StatServ */
		for (last = servhub->leaf; last && last->next; last = last->next)
			;
		if (!last) {
		    servhub->leaf = oneserver;
		} else {
		    last->next=oneserver;
		    oneserver->prev=last;
		}
		oneserver->hub = servhub;
	    } else {
#ifdef ALLOW_DEBUG
		if (debug)
		    log("New hub! Creating new map...");
#endif
		/* Retour d'un serveur, et c'est le (nouveau?) hub de StatServ */
		/* On rajoute le serveur StatServ */
		init_flystat_server();
		if (oneserver->leaf) {
		    /* On insere le serveur avant les autres leaf */
		    flystat->next = oneserver->leaf;
		    oneserver->prev = flystat;
		    oneserver->hub= NULL;
		}
		oneserver->leaf = flystat;
		flystat->hub = oneserver;

		/* on "recolle" les autres serveurs  la map
		 * last est forcement non NULL
		 * servmap->hub est lui par contre obligatoirement NULL
		 */
		for (last = flystat; last && last->next; last = last->next)
			;
		last->next = servmap;
		if (servmap)
		    servmap->prev = last;
		/* Le serveur est le nouveau hub des flystats! ya ouh :) */
		servmap = oneserver;
		log("New flystats hub is %s", oneserver->name);
	    }
	}
    } else {
	/* nouveau server */
	oneserver = calloc(sizeof(Server), 1);
	oneserver->name = strdup(cmd[1]);
	oneserver->desc = strdup(cmd[c-1]);
    
	servernum++;
	if (source) {
	    Server *last,
#ifdef IRC_UNDERNET
		*servhub = find_server_yxx(servmap, source[0]);
#else
		*servhub = find_server(servmap, source);
#endif
	    
	    for (last = servhub->leaf; last && last->next; last = last->next)
			;
	    if (!servhub->leaf) {
		servhub->leaf = oneserver;
	    } else {
		last->next=oneserver;
		oneserver->prev=last;
	    }
	    oneserver->hub = servhub;
#ifdef IRC_UNDERNET
            strncpy(oneserver->yxx, cmd[6], 3);
# ifdef ALLOW_DEBUG
            if (debug)
		log("New Server '%s' is '%c'", cmd[1], *cmd[6]);
# endif
#endif
	} else {
		/* Il s'agit du serveur qui hub StatServ */
	    log("Link with %s established", cmd[1]);
	    if (RemoteName)
		free(RemoteName);
	    RemoteName = strdup(cmd[1]);
#ifdef IRC_UNDERNET
	    if (strcmp(cmd[5]+1, "10")) {
		log("Unsupported protocol found on server %s", cmd[1]);
		SockWrite("%s :WARNING! Unsupported protocol found on server %s", WALLOPS, cmd[1]);
	    }
	    strncpy(oneserver->yxx, cmd[6], 3);
# ifdef ALLOW_DEBUG
	    if (debug)
		log("New Server '%s' is '%c'", cmd[1], *cmd[6]);
# endif
#endif
	    /* add services server */
	    init_flystat_server();
	    oneserver->leaf=flystat;
	    flystat->hub=oneserver;
	    if (servmap) {
		/* StatServ se reconnecte  un nouveau serveur hub qui
		 * n'est pas encore present dans la map
		 *  priori a a trs peu de chance d'arriver mais bon :)
		 */
		flystat->next = servmap;
		servmap->prev = flystat;
	    }
	    servmap = oneserver;
	}
    }
    oneserver->connected = 1;
    oneserver->pos = atoi(cmd[2])-1;
    oneserver->timelastjoin = time(NULL);
    oneserver->pingcount = oneserver->pongcount = oneserver->sendlastping = 0;
	/* Envois le message VERSION au serveur */
#ifdef IRC_UNDERNET
    SockWrite(":%s VERSION :%c", ssNick, oneserver->yxx[0]);
#else
    SockWrite("VERSION :%s", cmd[1]);
#endif
    return 1;
}

#ifdef IRC_UNDERNET
/* Pour les autres ircd que l'ircu 2.10.x cette fonction est
 * presente dans users.c */
void remove_server_users(Server *server)
{
    int i = 0;
    User *current, *u;

    do {
	current = NULL;
	while (i<122 && !current)
	    current = server->userlist[i++];
	while (current) {
	    u = current->yxx_next;
	    do_quit(current->nick, "flystats :)");
	    current = u;
	}
    } while (i<122);
    if (server->count) {
	log("Bogus userlist in server '%s', memory leaks", server->name);
    }
}
#endif

int do_squit(char *name)
{
    Server *server = find_server(servmap, name);
    if (!server) {
	log("Received SQUIT for unknown server %s", name);
	return 0;
    }
    log("Received SQUIT from server '%s'", name);
#if defined(IRC_UNDERNET)
    remove_server_users(server);
#endif
    servercount--;
    splitcount++;
    actualsplit++;
    dailysplitcount++;
    server->connected = 0;
    server->timelastsplit = time(NULL);
#if defined(IRC_UNDERNET) || defined(IRC_UNDERNET_29)
# ifdef IRC_UNDERNET
    squit_server_leaf(server);
# endif
    if (!strcmp(name, RemoteName)) {
	log("StatServ terminating...");
	quitflystats = 1;
    }
#endif
    return 1;
}

void ping_server(Server *server)
{
    Server *serv;

    for (serv = server; serv; serv = serv->next) {
	if (serv->connected == 1 && serv->pingcount == serv->pongcount) {
	    serv->pingcount++;
	    serv->sendlastping = time(NULL);
	    SockWrite(":%s PING %s :%s", ServerName, ServerName, serv->name);
	}
	if (serv->leaf) 
	    ping_server(serv->leaf);
    }
}

void do_pong(char *name)
{
    Server *server = find_server(servmap, name);
    if (!server) {
	log("Received PONG from unknown server '%s'", name);
	return;
    }
    server->lag = time(NULL) - server->sendlastping;
    server->pongcount++;
}

/* mets  jour les stats sur les servers */

void update_server_stats(Server *server, int timepos, int rzero)
{
    Server *serv;
    for (serv = server; serv; serv = serv->next) {
	if (serv->leaf)
	    update_server_stats(serv->leaf, timepos, rzero);
	if (!rzero) {
	    serv->averagecount[timepos]++;
	    serv->averagetotal[timepos]=serv->averagetotal[timepos]+serv->count;
	} else {
	    serv->averagecount[timepos]=1;
	    serv->averagetotal[timepos]=serv->count;
	}
	serv->average[timepos] = serv->averagetotal[timepos] / serv->averagecount[timepos];
    }
}

void update_net_stats(int timepos, int rzero)
{
    if (!rzero) {
	netaveragecount[timepos]++;
	netaveragetotal[timepos]=netaveragetotal[timepos]+usercount+invusercount;
    } else {
	netaveragecount[timepos]=1;
	netaveragetotal[timepos]=usercount+invusercount;
    }
    netaverage[timepos] = netaveragetotal[timepos] / netaveragecount[timepos];
}

/* Effacer un serveur et tous les serveurs relis de la map */
Server *remove_server_leaf(Server *server)
{
    Server *serv, *nextserv;

    for (serv = server; serv; serv = nextserv) {
	if (serv->leaf)
	    remove_server_leaf(serv->leaf);
	nextserv = serv->next;
	free(serv->name);
	free(serv->remote);
	free(serv->desc);
	if (serv->version)
	    free(serv->version);
	free(serv);
	actualsplit--;
	servernum--;
    }
    return NULL;
}

/* Propage le SQUIT aux serveurs relis */
Server *squit_server_leaf(Server *server)
{
    Server *serv;

    for (serv = server; serv; serv = serv->next) {
	if (serv->leaf)
	    squit_server_leaf(serv->leaf);
	if (serv->connected) {
	    remove_server_users(serv);
	    servercount--;
	    splitcount++;
	    dailysplitcount++;
	    serv->connected = 0;
	    serv->timelastsplit = time(NULL);
	}
    }
    return NULL;
}

/* Verifier si on peu afficher des statistiques sur le serveur */
int IgnoreServer(Server *server)
{
    int i;

    for (i=0; i < IgnoreServerCount; i++)
    if (!strcasecmp(server->name, IgnoreServerList[i]))
	return 1;
    return 0;
}
