/* FlyStats! is copyright (c) 1999-2000 CRESTO Sylvain <tost>.
 * E-mail: <tost@softhome.net>
 * Contact: #flystats on irc.kewl.org
 *
 * This program is free but copyrighted software; see the file COPYING for
 * details.
 */

#include "extern.h"

#ifdef IRC_UNDERNET
char ip_buf[8];
#endif

/*************************************************************************/

/* Connecte les services a un serveur (04/11/99)
 */
int ConnectFlyStats()
{
    struct hostent *hp;
    struct sockaddr_in sa;

    log("Connecting to <%s:%d>...", UsedRemoteServer->name, UsedRemoteServer->port);
    if (!(hp = gethostbyname (UsedRemoteServer->name)) || (serversock = socket(AF_INET, SOCK_STREAM, 0)) < 0)
        return -1;

    bzero(&sa, sizeof(sa));
    sa.sin_family = AF_INET;
    sa.sin_port = htons (UsedRemoteServer->port);
    bcopy(hp->h_addr, (char *) &sa.sin_addr, hp->h_length);

    if (RemoteServerIp)
	free(RemoteServerIp);
    if (strspn(UsedRemoteServer->name, "0123456789.") != strlen(UsedRemoteServer->name)) {
	RemoteServerIp = strdup(inet_ntoa(sa.sin_addr));
#ifdef ALLOW_DEBUG
	if (debug)
	    log("Server resolved to '%s'", RemoteServerIp);
#endif
    } else RemoteServerIp = NULL;

    if (connect (serversock, (struct sockaddr *) &sa, sizeof (sa)) < 0) {
	close (serversock);
	return -1;
    }

#ifdef IRC_UNDERNET
    inttobase64(ip_buf, ntohl(inet_addr(RemoteServerIp ? RemoteServerIp : UsedRemoteServer->name)), 6);
# ifdef ALLOW_DEBUG
    if (debug)
	log("IP# %s", ip_buf);
# endif
#endif

    return serversock;
}

/*************************************************************************/

void SockWrite(char *fmt,...)
{
    va_list ap;
    char buf[512];

    va_start (ap, fmt);
    vsnprintf (buf, 512, fmt, ap);

#ifdef ALLOW_DEBUG
    if (debug)
	log("Sends '%s'", buf);
#endif

    strcat (buf, "\n");

    if ((write(serversock, buf, strlen (buf))) == -1) {
	log("Write error");
    }
    va_end (ap);
}

int SockRead(char *c ,int s)
{
    int x=0,len;
    struct timeval tv;
    fd_set infd;

    tv.tv_sec=5;
    tv.tv_usec=0;

    FD_ZERO(&infd);
    FD_SET(s,&infd);

    c[0]='\0';

    while(1) {
	len=select(s+1,&infd,NULL,NULL,&tv);
	if(len > 0) {
	    if(recv(s, &c[x], 1, 0) < 0) {
		perror("recv");
		return(-1);
	    }
	    if (c[x]=='\r' || c[x]=='\n') {
		c[x]='\0';
		break;
	    }
	    if (x > 1024) {
		return(-1);
	    }
	    x++;
	} else if (!len) {
	    return(-2);
	} else if (len == -1){
	    return(-1);
	}
    }
    return (x);
}
